var args = arguments[0] || {};
//$.window.open();

var PageConstantNS = {
	detailsView : Ti.UI.createView({
		width : Ti.UI.FILL,
		height : Ti.UI.SIZE,
		layout : "vertical"
	}),
	collapseBtnImgView : Ti.UI.createImageView({
		width : 24,
		height : 24,
		image : "/images/qni/icons/expand.png",
		bubbleParent : false
	}),
	expandView : Ti.UI.createView({
		width : Ti.UI.FILL,
		height : Ti.UI.SIZE,
		backgroundColor : "transparent",
		layout : "vertical",
		top : 0
	}),
	expandListContainerView : Ti.UI.createView({
		width : Ti.UI.FILL,
		height : Ti.UI.SIZE,
		backgroundColor : "transparent",
		layout : "vertical",
		top : 0
	}),
	detailsHeight : null,
	shadowImgHeght : 6,
	mandatoryViewHeight : 56,
	detailsItems : null,
	firstTime : 1,
	secondTime : 2,
	detailsIntialHeight : null,
	validationMsgStyle : "validationMsgStyle",
	lblTyle : "Label",
	expandImgLink : "/images/qni/icons/expand.png",
	collapseImgLink : "/images/qni/icons/colapse.png",
	detailsLblTop : 16,
	directionUp : "up",
	directionDown : "down",
	fractionalHeight : 0.1,
	unity : 1,
	compositeLayout : "composite",
	verticalLayout : "vertical",
	zero : 0,
	animateDuration : 200,
	animatedZindex : 400000,
	hasValidationMsg : false,
	errDrawerShown: false
};


function showHideErrDrawer(){
	
}

/**
 * @Description: Function to add style dynamically
 * @visibility: element, styleName, elementType
 * @params: null
 * @return: null.
 */
function addStyle(element, styleName, elementType){
	element.applyProperties($.createStyle({
		classes : styleName,
		apiName : elementType
	}));
}

/**
 * @Description: Function to display error section
 * @visibility: private
 * @params: null
 * @return: null.
 */
function displayErrorSection(){
	// Condition to display validation messages
	if(PageConstantNS.hasValidationMsg){
		// Load details validation view
		manageDetailsView(true);
		
		// Animate view to downwards
		animateDetailsView();
	}
}

// Swipe Event added to parent view
$.helperView.addEventListener('swipe', function(event) {
	// For down swipe
	if(!isNullUndefinedEmptyInt(PageConstantNS)){
		if (PageConstantNS.directionDown === event.direction) {
			
			// // Condition to display validation messages
			// if(PageConstantNS.hasValidationMsg){
				// // Load details validation view
				// manageDetailsView(true);
	// 			
				// // Animate view to downwards
				// animateDetailsView();
			// }
			
			displayErrorSection();
			
			// $.widgetView.animate({
				// height : PageConstantNS.detailsHeight + PageConstantNS.shadowImgHeght,// - (OS_IOS ? 0 : PageConstantNS.animatedHeight),//Ti.UI.SIZE,//100,
				// duration : 200,
				// zIndex : 9999999999
			// }, function(){
				// $.detailsBottomShadowView.visible = true;
			// });
		}
		// For up swipe
		else if (PageConstantNS.directionUp === event.direction) {
			// Anumate upwards
			animateUp();
		}
	}
});

function showErrDrawer(event){
	if(PageConstantNS.hasValidationMsg){
		// Load details validation view
		manageDetailsView(true);
		
		// Animate view to downwards
		animateDetailsView();
	}
}

// Swipe event added to details validation view
$.widgetView.addEventListener('swipe', function(event) {
	// Condition for downward swipe
	if(!isNullUndefinedEmptyInt(PageConstantNS)){
		if (PageConstantNS.directionUp === event.direction) {
			// Hide details view
			hideDetailsView();
			// $.widgetView.animate({
				// height : 0.1,
				// duration : 200
			// }, function(){
				// $.detailsBottomShadowView.visible = false;
				// // $.validationDetailsView.height = 0.1;
				// manageDetailsView(false);
			// });
		}
		// Condition for upward swipe
		else if (PageConstantNS.directionDown === event.direction) {
			manageDetailsView(true);
			animateDetailsView();
			// $.widgetView.animate({
				// height : PageConstantNS.detailsHeight + PageConstantNS.shadowImgHeght -  - (OS_IOS ? 0 : PageConstantNS.animatedHeight),
				// duration : 200
			// },
			// function(){
				// $.detailsBottomShadowView.visible = true;
			// });
		}
	}
});

/**
 * @Description: Function to animate information view upwards
 * @visibility: validationBar
 * @params: null
 * @return: null.
 */
function animateUp(validationBar){
	// Assign the height of information view
	$.helperView.height = PageConstantNS.fractionalHeight;
	
	// Condition to hide parent view of information view
	if(validationBar){
		validationBar.visible = false;
	}
	else{
		// Hide parent view which is present in master page (QuoteEappBasicInformation page)
		$.helperView.getParent().getParent().visible = false;
	}
	
	// Remove all children. Dont know the reason this block of code is not working on Android
	if(OS_IOS){
		PageConstantNS.detailsView.removeAllChildren();
		manageDetailsView(false);
	}
}

/**
 * @Description: Function to animate information view downwards
 * @visibility: validationDetailsObj
 * @params: null
 * @return: null.
 */
function animateDown(validationDetailsObj){
	// Reset all items if exist any
	resetAllItems();
	
	// Assign height of information view, which is sum of helper view heigt + bottom shadow image height
	$.helperView.height = PageConstantNS.mandatoryViewHeight + PageConstantNS.shadowImgHeght;
	PageConstantNS.detailsItems = null;
	
	// Condition to set validation data
	if(validationDetailsObj){
		PageConstantNS.detailsItems = validationDetailsObj;
		
		// Assign max/min character view
		setCharacterView(validationDetailsObj);
		
		// Create view with for validation messages
		if(PageConstantNS.detailsItems.detailsValidation.length > PageConstantNS.zero){
			PageConstantNS.hasValidationMsg = true;
			makeErrorDetailsView(PageConstantNS.detailsItems, PageConstantNS.firstTime);
			// $.errDrawerParentView.setVisible(true);
			
			// Code to display error view automatically
			displayErrorSection();
		}
		else{
			PageConstantNS.hasValidationMsg = false;
		}
	}
}

/**
 * @Description: Function to initialize max/min character view
 * @visibility: validationDetailsObj
 * @params: null
 * @return: null.
 */
function setCharacterView(validationDetailsObj){
	// Condition to check max and minimum characters
	// have both max/min character
	if(validationDetailsObj.maxChar && validationDetailsObj.minChar){
		$.minCharLbl.text = validationDetailsObj.minChar +" " +L("minChar");
		$.maxCharLbl.text = validationDetailsObj.maxChar +" " +L("maxChar");
		// $.errDrawerParentView.right = 210;
	}
	// Have only max char
	else if(validationDetailsObj.maxChar && !validationDetailsObj.minChar){
		$.minCharLbl.visible = false;
		$.verticalBarView.visible = false;
		$.maxCharLbl.text = validationDetailsObj.maxChar +" " +L("maxChar");
		// $.errDrawerParentView.right = 105;
	}
	// Have only min char
	else if(!validationDetailsObj.maxChar && validationDetailsObj.minChar){
		$.characterView.remove($.verticalBarView);
		$.characterView.remove($.maxCharLbl);
		$.minCharLbl.text = validationDetailsObj.minChar +" " +L("minChar");
		// $.errDrawerParentView.right = 105;
	}
	// Dont have any max/min char
	else {
		$.characterView.visible = false;
		// $.errDrawerParentView.right = 0;
	}
}

/**
 * @Description: Function to create view with all validation messages
 * @visibility: detailsObj, loadAttempt
 * @params: null
 * @return: null.
 */
function makeErrorDetailsView(detailsObj, loadAttempt){
	var itemCountToBeLoad = PageConstantNS.zero;
	var addArrow = false;
	
	// Clear all values from UI if exist
	if(PageConstantNS.detailsView.children.length > PageConstantNS.zero){
		PageConstantNS.detailsView.removeAllChildren();
	}
	
	// Condition for single validation message
	if(detailsObj.detailsValidation.length === PageConstantNS.unity && loadAttempt === PageConstantNS.firstTime){
		// Assign heights for different elements
		PageConstantNS.detailsHeight = PageConstantNS.mandatoryViewHeight;
		PageConstantNS.detailsView.height = PageConstantNS.mandatoryViewHeight;
		PageConstantNS.detailsView.layout = PageConstantNS.compositeLayout;
		$.detailsBottomShadowView.top = PageConstantNS.mandatoryViewHeight;
		itemCountToBeLoad = PageConstantNS.unity;
		addArrow = false;
	}
	// Condition for messages more than one
	else if(detailsObj.detailsValidation.length > PageConstantNS.unity && loadAttempt === PageConstantNS.firstTime){
		PageConstantNS.detailsView.layout = PageConstantNS.verticalLayout;
		itemCountToBeLoad = PageConstantNS.unity;
		addArrow = true;
	}
	
	// Creates mesage labels
	_.each(detailsObj.detailsValidation, function(item, index){
		if(index <= (itemCountToBeLoad - PageConstantNS.unity)){
			var lbl = Ti.UI.createLabel({
				text : "* " + item
			});
			
			// Apply properties to label
			addStyle(lbl, PageConstantNS.validationMsgStyle, PageConstantNS.lblType);
			PageConstantNS.detailsView.add(lbl);
			lbl = null;
		}
	});
	
	// Add collapse/Expand button
	if(addArrow){
		PageConstantNS.detailsView.add(PageConstantNS.expandView);
		PageConstantNS.detailsView.add(PageConstantNS.collapseBtnImgView);
		var currentHeight = pixelToDpiUnits(PageConstantNS.detailsView.toImage().height);
		
		PageConstantNS.detailsHeight = currentHeight;
		PageConstantNS.detailsView.height = currentHeight;
		$.detailsBottomShadowView.top = currentHeight;
		
		// Add event listener
		addExpandListener();
		
		currentHeight = null;
	}
	itemCountToBeLoad = null;
	addArrow = null;
}

/**
 * @Description: Function to add event listener
 * @visibility: private
 * @params: null
 * @return: null.
 */
function addExpandListener(){
	PageConstantNS.collapseBtnImgView.image = PageConstantNS.expandImgLink;
	PageConstantNS.collapseBtnImgView.removeEventListener("click", showLess);
	PageConstantNS.collapseBtnImgView.addEventListener("click", showMore);
}

/**
 * @Description: Event to shw more
 * @visibility: private
 * @params: null
 * @return: null.
 */
function showMore(){
	// Load all validation messages
	displayMore();
	manageDetailsView(true);
	
	// Animate to view all messages
	animateDetailsView();
		// $.widgetView.animate({
			// top:0,
			// height : PageConstantNS.detailsHeight + PageConstantNS.shadowImgHeght,// - (OS_IOS ? 0 : PageConstantNS.animatedHeight),//Ti.UI.SIZE,//100,
			// duration : 200,
			// zIndex : 9999999999
		// }, function(){
			// $.detailsBottomShadowView.visible = true;
		// });
}

/**
 * @Description: Event to show more messages
 * @visibility: private
 * @params: null
 * @return: null.
 */
function displayMore(){
	var itemCountToBeLoad = PageConstantNS.zero;
	var detailsObj = PageConstantNS.detailsItems.detailsValidation;
	detailsObj = detailsObj.slice(PageConstantNS.unity, detailsObj.length);
	itemCountToBeLoad = detailsObj.length;
	var lblHeight = PageConstantNS.zero;
	
	// Load messages
	_.each(detailsObj, function(item, index){
		if(index <= (itemCountToBeLoad - PageConstantNS.unity)){
			var lbl = Ti.UI.createLabel({
				text : "* " + item
			});
			
			// Add styles
			addStyle(lbl, PageConstantNS.validationMsgStyle, PageConstantNS.lblType);
			
			// Get label height
			if(index === PageConstantNS.zero){
				lblHeight = pixelToDpiUnits(lbl.toImage().height);
			}
			PageConstantNS.expandView.add(lbl);
			lbl = null;
		}
	});
	var currentHeight = (lblHeight + PageConstantNS.detailsLblTop) * detailsObj.length;
	PageConstantNS.detailsIntialHeight = PageConstantNS.detailsHeight;
	
	
	PageConstantNS.detailsHeight += currentHeight;
	PageConstantNS.detailsView.height += currentHeight;
	$.detailsBottomShadowView.top = PageConstantNS.detailsView.height;// + currentHeight;
	
	// Update click listener
	collapseListner();
	
	currentHeight = null;
	itemCountToBeLoad = null;
	addArrow = null;
	lblHeight = null;
}

/**
 * @Description: Add collapse listener
 * @visibility: private
 * @params: null
 * @return: null.
 */
function collapseListner(){
	PageConstantNS.collapseBtnImgView.image = PageConstantNS.collapseImgLink;
	PageConstantNS.collapseBtnImgView.removeEventListener("click", showMore);
	PageConstantNS.collapseBtnImgView.addEventListener("click", showLess);
}

/**
 * @Description: Event to shw more
 * @visibility: private
 * @params: null
 * @return: null.
 */
function showLess(){
	displayLess();
	manageDetailsView(true);
	animateDetailsView();
		// $.widgetView.animate({
			// height : PageConstantNS.detailsHeight + PageConstantNS.shadowImgHeght,// - (OS_IOS ? 0 : PageConstantNS.animatedHeight),//Ti.UI.SIZE,//100,
			// duration : 200,
			// zIndex : 9999999999
		// }, function(){
			// $.detailsBottomShadowView.visible = true;
		// });
}

/**
 * @Description: Function to hide extra messages
 * @visibility: private
 * @params: null
 * @return: null.
 */
function displayLess(){
	PageConstantNS.expandListContainerView.removeAllChildren();
	PageConstantNS.expandListContainerView.height = Ti.UI.SIZE;
	PageConstantNS.expandView.removeAllChildren();
	PageConstantNS.expandView.height = Ti.UI.SIZE;
	
	PageConstantNS.detailsHeight = PageConstantNS.detailsIntialHeight;
	PageConstantNS.detailsView.height = PageConstantNS.detailsHeight;
	$.detailsBottomShadowView.top = PageConstantNS.detailsHeight;
	
	// Update click listener
	addExpandListener();
}

/**
 * @Description: Get height value
 * @visibility: private
 * @params: null
 * @return: null.
 */
function pixelToDpiUnits(pixel){
	if(OS_IOS){
		return pixel;
	}
	if(Ti.Platform.displayCaps.dpi > 160){
		return (pixel / ((Ti.Platform.displayCaps.dpi / 160)));
	}
	else{
		return pixel;
	}
}

/**
 * @Description: Function to manage details view
 * @visibility: private
 * @params: null
 * @return: null.
 */
function manageDetailsView(allowDisplay){
	if(allowDisplay){
		$.dataView.add(PageConstantNS.detailsView);
	}
	else{
		$.dataView.remove(PageConstantNS.detailsView);
	}
}

/**
 * @Description: Function to reset all elements
 * @visibility: private
 * @params: null
 * @return: null.
 */
function resetAllItems(){
	PageConstantNS.expandView.removeAllChildren();
	PageConstantNS.expandView.height = Ti.UI.SIZE;
	PageConstantNS.detailsItems = null;
	PageConstantNS.detailsHeight = [];//null;
	PageConstantNS.detailsIntialHeight = null;
}

/**
 * @Description: Function to animate details view to show more
 * @visibility: private
 * @params: null
 * @return: null.
 */
function animateDetailsView(){
	$.widgetView.height = PageConstantNS.detailsHeight + PageConstantNS.shadowImgHeght;
	$.widgetView.animate({
		// height : PageConstantNS.detailsHeight + PageConstantNS.shadowImgHeght,
		opacity: 1,
		duration : PageConstantNS.animateDuration,
		zIndex : PageConstantNS.animatedZindex
	}, function(){
		$.detailsBottomShadowView.visible = true;
	});
	$.errDrawerSwitch.image = "/images/qni/icons/switch_error.png";
	PageConstantNS.errDrawerShown = true;
}

/**
 * @Description: Function to animate details view to hide extra one
 * @visibility: private
 * @params: null
 * @return: null.
 */
function hideDetailsView(){
	$.widgetView.animate({
		opacity: 0,
		duration : PageConstantNS.animateDuration
	}, function(){
		$.widgetView.height = PageConstantNS.fractionalHeight;
		$.detailsBottomShadowView.visible = false;
		manageDetailsView(false);
	});
	$.errDrawerSwitch.image = "/images/qni/icons/switch_info.png";
	PageConstantNS.errDrawerShown = false;
}

/**
 * @Description: Function to clear widget
 * @visibility: private
 * @params: null
 * @return: null.
 */
function clearWidget(){
	PageConstantNS = null;
}

// function handleErrBtnTouch(event){
	// if('touchstart' === event.type){
		// addStyle($.errDrawerOpenImgView, 'errDrawerOpenImgViewEnabledStyle' , 'ImageView');
	// } else if('touchend' === event.type){
		// addStyle($.errDrawerOpenImgView, 'errDrawerOpenImgViewStyle' , 'ImageView');
	// }
// }

function hideErrorDrawer(event){
	if(PageConstantNS.hasValidationMsg){
		hideDetailsView();
	}
}

function showHideErrDrawer(event){
	if(PageConstantNS.hasValidationMsg){
		if(!PageConstantNS.errDrawerShown){
			showErrDrawer();
		} else {
			hideErrorDrawer();
		}
	}
}

exports.animateUp = animateUp;
exports.animateDown = animateDown;
exports.clearWidget = clearWidget;
