/**
 * @Created: 6th Jan 2015
 * @Author: Cognizant
 * @Description: This file will contain all color code.
 */
/****************************************************************************************************************
 * Revision History
 * ****************
 *	Modified By(svn id)		Modified Date				Changed for(brief description)
 *  -------------------		-------------				------------------------------
 * 	phald					15-Jan-2015					added color ACE_BLACK_85
 * smukh					17-Mar-2015					added colors ACE_BLACK_50
 * cgupt					05-May-2015				   	added colors ACE_BLACK_30
 * smukh					6-May-2015					added colors ACE_GREEN_HEADER ,ACE_BLUE_SHADE_2
 * smukh					10-Aug-2015					added color for quote list screen
 * smukh					10-Aug-2015					added color for quote eapp drawer widget
 * smukh					10-Aug-2015					added color for action bar for quote list
 * smond					10-Sept-2015				Added color for illustration Screen.
 * rmah						11 Sep 2015					Added new colors
 * rmah						29 Oct 2015					Added new color
 * smukh					27 Nov 2015					Added orange color
 * smukh					07 Dec 2015					Added gray color
 * smukh					15 Dec 2015					Added gray color
 * smukh					05 Jan 2015					Added colors for gray shade for overveiw screen
 * uchak					14 Jan 2015					Added colors ACE_GRAY_70 for gray in Questionnaires
 * rmah						15 Feb 2016					Added new color
 * ***************************************************************************************************************/

/**
 * @Description: Function to get all ace colors
 * @visibility: public
 * @params: null
 * @return: color list.
 */
exports.getAceColors = function() {
	return ( {
		ACE_GRAY : "#333F48",
		LIGHT_GRAY : "#CBC4BC",
		// ACE_GRAY_50 : "#a5a5a5",
		ACE_WHITE : "#FFFFFF",
		ACE_BLACK : "#000000",
		ACE_BLUE : "#05C3DE",
		ACE_GREEN : "#99CC00",
		GRAY : "#5C656D",
		TRANSPARENT : "transparent",
		ACE_BLACK_90 : "rgb(40,40,40)",
		ACE_GRAY_10 : OS_IOS ? "rgba(51,63,72,0.1)" : "#1A333F48",
		ACE_GRAY_45 : "#828A8E",
		ACE_GRAY_20 : OS_IOS ? "rgba(195,204,209,0.2)" : "#33c3ccd1",
		ACE_GRAY_30 : OS_IOS ? "rgba(51,63,72,0.3)" : "#4D333F48",
		ACE_GRAY_40 : "#66333F48",
		ACE_GRAY_50 : OS_IOS ? "rgba(51,63,72,0.5)" : "#80333F48",
		ACE_GRAY_60 : OS_IOS ? "rgba(51,63,72,0.5)" : "#99333F48",
		ACE_BLACK_60 : OS_IOS ? "rgba(0,0,0,0.6)" : "#99000000",
		ACE_GRAY_75 : OS_IOS ? "rgba(51,63,72,0.75)" : "#BF333F48",
		ACE_OVERLAY_30 : OS_IOS ? "rgba(223,229,230,0.3)" : "#4DDFE5E6",
		GRAY_40 : OS_IOS ? "rgba(195,204,209,0.4)" : "#66c3ccd1",
		ACE_BLACK_85 : OS_IOS ? "rgba(0,0,0,0.85)" : "#D9000000",
		ACE_BLACK_50 : OS_IOS ? "rgba(0,0,0,0.5)" : "#80000000",
		ACE_BLACK_40 : OS_IOS ? "rgba(0,0,0,0.4)" : "#66000000",
		ACE_BLACK_30 : OS_IOS ? "rgba(0,0,0,0.3)" : "#4D000000",
		ACE_GREEN_HEADER : "#84bd00",
		ACE_BLUE_SHADE_2 : "#1C8193",
		ACE_WHITE_SHADE_1 : "#fcfbfd",
		ACE_GRAY_SHADE_1 : "#eff4f7",
		ACE_BLUE_SHADE_3 : "#004c97",
		ACE_BLACK_40 : "#66000000",
		ACE_WHITE_40 : OS_IOS ? "rgba(255, 255, 255, 0.4)" : "#66FFFFFF",
		ACE_WHITE_20 : OS_IOS ? "rgba(255, 255, 255, 0.2)" : "#33FFFFFF",
		ACE_GREEN_LINE : "#84BC00",
		ACE_BLUE_004C97 : "#004C97",
		ACE_RED : "#E4002B",
		ACE_BLACK_20 : OS_IOS ? "rgba(0,0,0,0.2)" : "#33000000",
		ACE_WHITE_60 : "#99FFFFFF",
		ACE_YELLOW : "#FFBB1C",
		ACE_YELLOW_FFB81C : "#FFB81C",
		ACE_YELLOW_FFB71B : "#FFB71B",
		ACE_YELLOW_FFB71B_80 : OS_IOS? "rgba(255,183,27, 0.8)" : "#CCFFB71B",
		ACE_BLACK_75 : OS_IOS ? "rgba(0, 0, 0, 0.75)" : "#BF000000",
		ACE_BLACK_22 : "#33000000",
		ACE_BLACK_B2B2B2 : "#4DB2B2B2",
		ACE_WHITE_80 : OS_IOS ? "rgba(255,255,255,0.8)" : "#CCFFFFFF",
		ACE_GRAY_NEW_20 : "#33333F48",
		ACE_WHITE_50 : OS_IOS ? "rgba(255, 255, 255, 0.5)" : "#80FFFFFF",
		ACE_WHITE_25 : OS_IOS ? "rgba(255, 255, 255, 0.25)" : "#40FFFFFF",
		ACE_SEARCH_BLUE : "#05C3DD",
		ACE_SEARCH_BLUE_40 : OS_IOS ? "rgba(5, 195, 221, 0.4)" : "#6605C3DD",
		ACE_BLUE_5 : OS_IOS ? "rgba(5, 195, 221, 0.05)" : "#0D05C3DD",
		ACE_BLACK_10 : "#1A000000",
		ACE_GRAY_SHADE_2 : "#DFE1E2",
		ACE_GRAY_SHADE_3 : "#DFE5E6",
		ACE_WHITE_75 : "#BFFFFFFF",
		ACE_VIOLET_30 : OS_IOS ? "rgba(173,149,219,0.3)" : "#4DAD95DB",
		ACE_GRAY_SHADE_20 : OS_IOS ? "rgba(51,63,72,0.2)" : "#33333F48",
		ACE_BLUE_SHADE_1 : "#26004B97",
		ACE_DARK_GREEN : "#00664F",
		ACE_RED_FF5A60 : "#FF5A60",
		ACE_RED_E3002B : "#E3002B",
		ACE_RED_FF5A60_40 : "#66FF5A60",
		ACE_BLUE_SHADE_4 : "#0D004B97",
		ACE_BLACK_0 : OS_IOS ? "rgba(0, 0, 0, 0)" : "#00000000",
		ACE_GRAY_SHADE_3_30 : OS_IOS ? "rgba(223, 229, 230, 0.3)" :  "#4DDFE5E6",
		ACE_BLUE_05C3DD : "#05C3DD",
		ACE_ORANGE : "#FE5000",
		ACE_GRAY_SHADE_SIDE_DRAWER : OS_IOS ? "rgba(223,229,230,1)" : "#DFE5E6",
		ACE_GRAY_SHADE_SIDE_DRAWER_50 : OS_IOS ? "rgba(223,229,230,0.5)" : "#80DFE5E6",
		ACE_BLUE_004B97 : "#004B97",
		ACE_GRAY_77868B :"#77868B",
		ACE_WHITE_10 : "#1AFFFFFF",
		ACE_BLUE_SHADE_5 : "#59004B97",
		ACE_WHITE_05 : "#0DFFFFFF",
		ACE_BLUE_004C97_40: OS_IOS ? "rgba(0, 76, 151, 0.4)" :  "#66004C97",
		ACE_RED_ERROR_SELECTION: "#F8B3B6",
		ACE_BLUE_DROPDOWN_SELECTION: "#8CB2CF",
		ACE_YELLOW_FFC251 : "#FFC251",
		ACE_ORANGE_EE5000 : "#EE5000",
		ACE_GRAY_9D9D9C : "#9D9D9C",
		ACE_ORANGE_80 : "#fe6119",
		ACE_GRAY_858C91 : "#858C91",
		ACE_GRAY_B2B2B2 : "#B2B2B2",
		ACE_GRAY_858C91_10 : "#1A858C91",
		ACE_GRAY_B2B2B2_10 : "#1AB2B2B2",
		ACE_GRAY_EFF2F2 : "#EFF2F2",
		ACE_BLUE_33A6C1DB : "#33a6c1db",
		ACE_BLUE_33004B97 : "#33004b97",
		ACE_GREEN_84BD00 : "#84bd00",
		ACE_LIGHT_BLUE_FF05C3DD : "#FF05c3dd",
		ACE_GRAY_70 : "#B3333F48",
		ACE_GRAY_RED_EB1A3F : "#EB1A3F",
		ACE_GRAY_757575 : "#757575",
		ACE_BLACK_80 : OS_IOS ? "rgba(0,0,0,0.8)" : "#CC000000",
		ACE_BLACK_212121: "#212121",
		ACE_GRAY_616A71: "#616A71"
	});
}; 
